/*
-----------------------------------------------------------------------------
This source file is part of the GameTools Project
http://www.gametools.org

Author: Martin Szydlowski
-----------------------------------------------------------------------------
*/

#include "OgreKdTreeSceneManager.h"
#include "OgreKdTreeHierarchyInterface.h"

namespace Ogre
{

KdTreeHierarchyInterface::KdTreeHierarchyInterface(KdTreeSceneManager *sm, RenderSystem *rsys):
PlatformHierarchyInterface(sm, rsys)
{

}

bool KdTreeHierarchyInterface::IsLeaf(GtpVisibility::HierarchyNode *node) const
{
	return KDNODEPTR_CAST(node)->isLeaf();
}

void KdTreeHierarchyInterface::TraverseNode(GtpVisibility::HierarchyNode *node)
{
	++ mNumTraversedNodes;

	KdTree::Node * kdnode = KDNODEPTR_CAST(node);

	// if the node is a leaf and has geometry => render it
	if (kdnode->isLeaf())
	{
		if (!kdnode->isEmpty())
		{
			RenderNode(node);
		}
	}
	else
	{
		KdTree::Branch * kdbranch = KDBRANCHPTR_CAST(node);
		if (kdbranch->mLeft)
			mDistanceQueue->push(kdbranch->mLeft);
		if (kdbranch->mRight)
			mDistanceQueue->push(kdbranch->mRight);
	}
}

void KdTreeHierarchyInterface::RenderNode(GtpVisibility::HierarchyNode *node)
{
	/*** TODO ***/
}

void KdTreeHierarchyInterface::PullUpVisibility(GtpVisibility::HierarchyNode *node) const
{
	/*** TODO ***/
}

float KdTreeHierarchyInterface::GetSquaredDistance(GtpVisibility::HierarchyNode *node) const
{
	/*** TODO ***/
	return 0.0;
}

AxisAlignedBox * KdTreeHierarchyInterface::GetBoundingBox(GtpVisibility::HierarchyNode *node)
{
	/*** TODO ***/
	return new AxisAlignedBox();
}

bool KdTreeHierarchyInterface::HasGeometry(GtpVisibility::HierarchyNode *node) const
{
	return KDNODEPTR_CAST(node)->hasGeometry();
}

void KdTreeHierarchyInterface::SetNodeVisible(GtpVisibility::HierarchyNode *node, const bool visible) const
{
	/*** TODO ***/
}

bool KdTreeHierarchyInterface::IsNodeVisible(GtpVisibility::HierarchyNode *node) const
{
	/*** TODO ***/
	return true;
}

void KdTreeHierarchyInterface::SetLastVisited(GtpVisibility::HierarchyNode *node, const unsigned int frameId) const
{
	/*** TODO ***/
}

unsigned int KdTreeHierarchyInterface::LastVisited(GtpVisibility::HierarchyNode *node) const
{
	/*** TODO ***/
	return 0;
}

void KdTreeHierarchyInterface::VisualizeCulledNode(GtpVisibility::HierarchyNode *node, 
												   GtpVisibility::CullingType type) const
{
	/*** TODO ***/
}

void KdTreeHierarchyInterface::GetNodeGeometryList(GtpVisibility::HierarchyNode *node, 
												   GtpVisibility::GeometryVector *geometryList, 
												   bool includeChildren) 
{
	/*** TODO ***/
}

} // namespace Ogre